﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.AccessControl;
using System.Threading;

namespace Prohlizec_obrazku
{
    public partial class Nahledy : Form
    {
        string open = "";
        string select = "";
        public Nahledy(string dir_or_file)
        {
            if(Directory.Exists(dir_or_file))
                select=dir_or_file;
            if(File.Exists(dir_or_file))
            {
                open=dir_or_file;
            }
            InitializeComponent();
            foreach (DriveInfo di in DriveInfo.GetDrives())
            {
                if (di.IsReady)
                {
                    TreeNode tn = new TreeNode(di.RootDirectory.Name.Substring(0, di.RootDirectory.Name.LastIndexOf('\\')));

                    Vytvor_strom(tn, di.RootDirectory.FullName);
                    treeView1.Nodes.Add(tn);
                }
            }
       }
        public void Vytvor_strom(TreeNode treenode,string cesta)
        {
            DirectorySecurity security = Directory.GetAccessControl(cesta);
            if (!security.AreAccessRulesProtected)
            {
                string[] adresare = Directory.GetDirectories(cesta);
                TreeNode[] tn=new TreeNode[adresare.Length];
                for (int i = 0; i < adresare.Length; i++)
                {
                    string[] adresar = adresare[i].Split('\\');
                    tn[i]=new TreeNode(adresar[adresar.Length-1]);
                    Vytvor_strom(tn[i],adresare[i]);
                }
                treenode.Nodes.AddRange(tn);
            }
        }
        
        
        private void treeView1_DoubleClick(object sender, EventArgs e)
        {
            Thread th = new Thread(new ParameterizedThreadStart(addobr));
            th.IsBackground = true;
            treeView1.SuspendLayout();
             string cesta= treeView1.SelectedNode.FullPath;
            string[] obrazky= Directory.GetFiles(cesta, "*.jp*g");
            th.Start(new object[] { new pridejobr(pridejObr), obrazky });
           listView1.LargeImageList = new ImageList();
            listView1.LargeImageList.ImageSize = new Size(80, 80);
            listView1.LargeImageList.ColorDepth = ColorDepth.Depth32Bit;
            listView1.Items.Clear();
            treeView1.ResumeLayout();
        }
        public delegate void pridejobr(Image img, string[] obrazky, int i);
        public delegate void prideobr();
        public void pridejObr(Image img,string[] obrazky,int i)
        {
            prideobr p = delegate()
            {
                treeView1.SuspendLayout();
                string[] obrazek = obrazky[i].Split('\\');
                ListViewItem lvi = new ListViewItem();
                Image obr = Image.FromFile(obrazky[i]);
                listView1.LargeImageList.Images.Add(obr);
                listView1.Items.Add(lvi);
                lvi.ImageIndex = i;
                lvi.Tag = obrazky[i];
                lvi.Text = obrazek[obrazek.Length - 1];
                lvi.Text += "\n" + File.GetCreationTime(obrazky[i]);
                lvi.Text += "\n" + Preved_na_nej_jedno(File.ReadAllBytes(obrazky[i]).Length);
                lvi.Text += "\n" + obr.Size.Width.ToString() + "x" + obr.Size.Height.ToString();
                lvi.ToolTipText = lvi.Text;
                treeView1.ResumeLayout();
            };
            if (listView1.InvokeRequired)
            {
                listView1.Invoke(p);
            }
            else
            {
                treeView1.SuspendLayout();
                string[] obrazek = obrazky[i].Split('\\');
                ListViewItem lvi = new ListViewItem();
                 Image obr= Image.FromFile(obrazky[i]);
                 listView1.LargeImageList.Images.Add(obr);
                listView1.Items.Add(lvi);
                lvi.ImageIndex = i;
                lvi.Tag = obrazky[i];
                lvi.Text = obrazek[obrazek.Length - 1];
                lvi.Text += "\n" + File.GetCreationTime(obrazky[i]);
                lvi.Text += "\n" + Preved_na_nej_jedno(File.ReadAllBytes(obrazky[i]).Length);
                lvi.Text += "\n" + obr.Size.Width.ToString() + "x" + obr.Size.Height.ToString();
                lvi.ToolTipText = lvi.Text;
                treeView1.ResumeLayout();
            }
        }
        public static void addobr(object data)
        {
            object[] pom=(object[])data;
            pridejobr priobr = (pridejobr)pom[0];
            string[] obrazky = (string[])pom[1];
            for (int i = 0; i < obrazky.Length; i++)
            {

                string[] obrazek = obrazky[i].Split('\\');
                Image obr = Image.FromFile(obrazky[i]);
                priobr(obr,obrazky,i);
            }
        }
        public static string Preved_na_nej_jedno(float bytes)
        {
            string jednotky="B";
            if (bytes >= 1024)
            {
                jednotky = "Kb";
                bytes /= 1024;
            }
            if (bytes >= 1024)
            {
                jednotky = "Mb";
                bytes /= 1024;
            }
            if (bytes >= 1024)
            {
                jednotky = "Gb";
                bytes /= 1024;
            } if (bytes >= 1024)
            {
                jednotky = "Tb";
                bytes /= 1024;
            }
            return Math.Round(bytes).ToString() + " " + jednotky;
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
                Close();
        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                Prepnout(true,listView1.SelectedItems[0].Tag.ToString());
        }
        Zobrazeni z;
        public void Prepnout(bool zobrazeni,string obr)
        {
            if (zobrazeni)
            {
                if(z==null||z.IsDisposed)
                z = new Zobrazeni(obr, this);
                z.Show();
                this.WindowState = FormWindowState.Minimized;
                this.Hide();
            }
            else
            {
                if(obr!="nasilne")
                z.Close();
                this.Show();
                this.WindowState = FormWindowState.Normal;
            }
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            Prepnout(true, listView1.SelectedItems[0].Tag.ToString());
        }

        private void Nahledy_Load(object sender, EventArgs e)
        {
            if (open.Length > 0)
            {
                Prepnout(true, open);
            }
            if (select.Length > 0)
            {
                string[] select_path=select.Split('\\');
                selectNode(treeView1.Nodes, select_path, 0);
                treeView1.SuspendLayout();

                string[] obrazky = Directory.GetFiles(select, "*.jp*g");
                listView1.LargeImageList = new ImageList();
                listView1.LargeImageList.ImageSize = new Size(80, 80);
                listView1.LargeImageList.ColorDepth = ColorDepth.Depth32Bit;
                listView1.Items.Clear();
                for (int i = 0; i < obrazky.Length; i++)
                {

                    string[] obrazek = obrazky[i].Split('\\');
                    ListViewItem lvi = new ListViewItem();
                    Image obr = Image.FromFile(obrazky[i]);
                    listView1.LargeImageList.Images.Add(obr);
                    listView1.Items.Add(lvi);
                    lvi.ImageIndex = i;
                    lvi.Tag = obrazky[i];
                    lvi.Text = obrazek[obrazek.Length - 1];
                    lvi.Text += "\n" + File.GetCreationTime(obrazky[i]);
                    lvi.Text += "\n" + Preved_na_nej_jedno(File.ReadAllBytes(obrazky[i]).Length);
                    lvi.Text += "\n" + obr.Size.Width.ToString() + "x" + obr.Size.Height.ToString();
                    lvi.ToolTipText = lvi.Text;
                }
                treeView1.ResumeLayout();
            }
       
        }
        private void selectNode(TreeNodeCollection nodes, string[] cesta,int index)
        {
            foreach (TreeNode tn in nodes)
            {
                if (tn.Text == cesta[index])
                {
                    tn.Expand();
                    selectNode(tn.Nodes, cesta, index + 1);
                    return;
                }
            }
        }
    }
}
