﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Prohlizec_obrazku
{
    public partial class Zobrazeni : Form
    {
        float factor = 1f;
        Image zaklad;
        Nahledy nahledy;
        string[] obrazky_v_adresari;
        int poradi_v_adresari=-1;
        public Zobrazeni(string obrazek,Nahledy nahledy)
        {
            InitializeComponent();
            this.nahledy = nahledy;
            Nacteni(obrazek);
        }
        private void Nacteni(string obrazek)
        {
            string[] obr = obrazek.Split('\\');
            label4.Text = "0/0";
            label1.Text = string.Format("Název: {0,-30:G} Velikost: {1,-15:G}", obr[obr.Length - 1], Nahledy.Preved_na_nej_jedno(File.ReadAllBytes(obrazek).Length));
            label2.Text = string.Format("Vytvořeno: {0,-20:D} Rozměry: {1,-15:G}", File.GetCreationTime(obrazek), "");
           
            pictureBox1.Image = Image.FromFile(obrazek);
            label2.Text = string.Format("Vytvořeno: {0,-20:D} Rozměry: {1,-15:G}", File.GetCreationTime(obrazek), pictureBox1.Image.Size.Width+"x"+pictureBox1.Image.Size.Height);
            label3.Text = "Zoom: "+factor.ToString();
            zaklad = pictureBox1.Image;
            label4.Text= poradi(obrazek.Substring(0,obrazek.LastIndexOf('\\')),obr[obr.Length-1]);
            if (poradi_v_adresari - 1 < 0)
                button2.Enabled = button4.Enabled = false;
            if (poradi_v_adresari + 1 >= obrazky_v_adresari.Length)
                button1.Enabled = button3.Enabled = false;
              
        }
        private string poradi(string cesta,string nazev)
        {
            obrazky_v_adresari = Directory.GetFiles(cesta, "*.jp*g");
            for (int i = 0; i < obrazky_v_adresari.Length; i++)
            {
                string[] obrazek = obrazky_v_adresari[i].Split('\\');
                if (obrazek[obrazek.Length - 1] == nazev)
                {
                    poradi_v_adresari = i;
                    return (i + 1) + "/" + obrazky_v_adresari.Length;
                }
            }
            return "0/0";
        
        }

        private void Zobrazeni_KeyDown(object sender, KeyEventArgs e)
        {
            //107+
            //109-
            if (e.KeyCode == Keys.H)
            {
                factor = 1f;
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
                zaklad.RotateFlip(RotateFlipType.RotateNoneFlipY);
                pictureBox1.Image = zaklad;
            }
            if (e.KeyCode == Keys.V)
            {
                factor = 1f;
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
                zaklad.RotateFlip(RotateFlipType.RotateNoneFlipX);
                pictureBox1.Image = zaklad;
            }
            if (e.KeyCode == Keys.R)
            {
                factor = 1f;
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
                zaklad.RotateFlip(RotateFlipType.Rotate90FlipNone);
                pictureBox1.Image = zaklad;
            }
            if (e.KeyCode == Keys.L)
            {
                factor = 1f;
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
                zaklad.RotateFlip(RotateFlipType.Rotate270FlipNone);
                pictureBox1.Image = zaklad;
            }
            if (e.KeyValue == 109)
            {
                pictureBox1.SizeMode = PictureBoxSizeMode.CenterImage;
                factor /=1.1f;
                pictureBox1.Image = scale(zaklad, factor);
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
            }
            if (e.KeyValue == 107)
            {
                pictureBox1.SizeMode = PictureBoxSizeMode.CenterImage;
                factor *= 1.1f;
                pictureBox1.Image = scale(zaklad, factor);
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
            }
            if (e.KeyValue == 106)
            {
                pictureBox1.SizeMode = PictureBoxSizeMode.CenterImage;
                factor = 1f;
                pictureBox1.Image = scale(zaklad, factor);
                label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
             }
            if (e.KeyValue == 111)
            {
                factor = 1f;
                pictureBox1.Image = scale(zaklad, factor);
                pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
                label3.Text = "Zoom: Na celou obrazovku";
            }
            if (e.KeyCode == Keys.Home)
            {
                if (button4.Enabled)
                {
                    button1.Enabled = button2.Enabled = button3.Enabled = button4.Enabled = true;
                    Nacteni(obrazky_v_adresari[0]);
                }
            }
            if (e.KeyCode == Keys.End)
            {
                if (button3.Enabled)
                {
                    button1.Enabled = button2.Enabled = button3.Enabled = button4.Enabled = true;
                    Nacteni(obrazky_v_adresari[obrazky_v_adresari.Length - 1]);
                }
            }
            if (e.KeyCode == Keys.PageUp)
            {
                if (button2.Enabled)
                {
                    if (poradi_v_adresari - 1 > 0)
                        button1.Enabled = button3.Enabled = true;
                    else
                        button2.Enabled = button4.Enabled = false;
                    Nacteni(obrazky_v_adresari[poradi_v_adresari - 1]);
                }
            }
            if (e.KeyCode == Keys.PageDown)
            {
                if (button1.Enabled)
                {
                    if (poradi_v_adresari + 1 >= obrazky_v_adresari.Length)
                        button1.Enabled = button3.Enabled = false;
                    else
                        button2.Enabled = button4.Enabled = true;
                    Nacteni(obrazky_v_adresari[poradi_v_adresari + 1]);
                }
            }
            if (e.KeyCode == Keys.Enter)
                nahledy.Prepnout(false, "");
            if (e.KeyCode == Keys.Escape)
                Application.Exit();
        }

        private void Zobrazeni_FormClosing(object sender, FormClosingEventArgs e)
        {
            nahledy.Prepnout(false, "nasilne");
        }
        private Image scale(Image obrazek,float factor)
        {
            Bitmap b = new Bitmap((int)(obrazek.Size.Width * factor), (int)(obrazek.Size.Height * factor));
            Graphics g = Graphics.FromImage(b);
            g.DrawImage(obrazek, 0, 0, b.Width, b.Height);
            g.Flush();
            return b;
        }

        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            nahledy.Prepnout(false, "");
       
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (poradi_v_adresari + 1 >= obrazky_v_adresari.Length)
                button1.Enabled = button3.Enabled = false;
            else
                button2.Enabled = button4.Enabled = true;
            Nacteni(obrazky_v_adresari[poradi_v_adresari + 1]);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (poradi_v_adresari-1>0)
                button1.Enabled = button3.Enabled = true;
            else
                button2.Enabled = button4.Enabled = false;
            Nacteni(obrazky_v_adresari[poradi_v_adresari - 1]);
        
        }

        private void button3_Click(object sender, EventArgs e)
        {
            button1.Enabled = button2.Enabled = button3.Enabled = button4.Enabled = true;
            Nacteni(obrazky_v_adresari[obrazky_v_adresari.Length - 1]);
        
        }

        private void button4_Click(object sender, EventArgs e)
        {
            button1.Enabled = button2.Enabled = button3.Enabled = button4.Enabled = true;
            Nacteni(obrazky_v_adresari[0]);
       
        }

        private void button5_Click(object sender, EventArgs e)
        {
            factor *= 1.1f;
            pictureBox1.Image = scale(zaklad, factor);
            label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
         
        }

        private void button6_Click(object sender, EventArgs e)
        {
            factor /= 1.1f;
            pictureBox1.Image = scale(zaklad, factor);
            label3.Text = "Zoom: " + ((float)Math.Round(factor * 100) / 100).ToString();
         
        }

    }
}
